Loading...
Searching...
No Matches
p_Numbers.h File Reference
`#include "misc/auxiliary.h"`
`#include "coeffs/coeffs.h"`
`#include "coeffs/numbers.h"`
`#include "polys/monomials/ring.h"`
`#include "coeffs/modulop.h"`
`#include "coeffs/modulop_inl.h"`
`#include "coeffs/longrat.cc"`

Go to the source code of this file.

## Macros

#define | n_Copy_RingGeneral(n, r)
#define | n_Delete_RingGeneral(n, r)
#define | n_Mult_RingGeneral(n1, n2, r)
#define | n_Add_RingGeneral(n1, n2, r)
#define | n_IsZero_RingGeneral(n, r)
#define | n_Equal_RingGeneral(n1, n2, r)
#define | n_Neg_RingGeneral(n, r)
#define | n_Sub_RingGeneral(n1, n2, r)
#define | n_InpMult_RingGeneral(n1, n2, r)
#define | n_InpAdd_RingGeneral(n1, n2, r)
#define | n_Copy_FieldZp(n, r)
#define | n_Delete_FieldZp(n, r)
#define | n_Mult_FieldZp(n1, n2, r)
#define | n_Add_FieldZp(n1, n2, r)
#define | n_Sub_FieldZp(n1, n2, r)
#define | n_IsZero_FieldZp(n, r)
#define | n_Equal_FieldZp(n1, n2, r)
#define | n_Neg_FieldZp(n, r)
#define | n_InpMult_FieldZp(n1, n2, r)
#define | n_InpAdd_FieldZp(n1, n2, r)
#define | DO_LFORCE_INLINE
#define | n_Copy_FieldQ(n, r)
#define | n_Delete_FieldQ(n, r)
#define | n_Mult_FieldQ(n1, n2, r)
#define | n_Add_FieldQ(n1, n2, r)
#define | n_Sub_FieldQ(n1, n2, r)
#define | n_IsZero_FieldQ(n, r)
#define | n_Equal_FieldQ(n1, n2, r)
#define | n_Neg_FieldQ(n, r)
#define | n_InpMult_FieldQ(n1, n2, r)
#define | n_InpAdd_FieldQ(n1, n2, r)

## Functions

static FORCE_INLINE number | n_Copy_FieldGeneral (number n, const coeffs r)
static FORCE_INLINE void | n_Delete_FieldGeneral (number *p, const coeffs r)
static FORCE_INLINE number | n_Mult_FieldGeneral (number n1, number n2, const coeffs r)
static FORCE_INLINE number | n_Add_FieldGeneral (number n1, number n2, const coeffs r)
static FORCE_INLINE BOOLEAN | n_IsZero_FieldGeneral (number n, const coeffs r)
static FORCE_INLINE BOOLEAN | n_Equal_FieldGeneral (number n1, number n2, const coeffs r)
static FORCE_INLINE number | n_Neg_FieldGeneral (number n, const coeffs r)
static FORCE_INLINE number | n_Sub_FieldGeneral (number n1, number n2, const coeffs r)
static FORCE_INLINE void | n_InpMult_FieldGeneral (number &n1, number n2, const coeffs r)
static FORCE_INLINE void | n_InpAdd_FieldGeneral (number &n1, number n2, const coeffs r)

## Macro Definition Documentation

## DO_LFORCE_INLINE

#define DO_LFORCE_INLINE

Definition at line 75 of file p_Numbers.h.

## n_Add_FieldQ

#define n_Add_FieldQ | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
nlAdd(n1,n2,r)
nlAdd
LINLINE number nlAdd(number la, number li, const coeffs r)
Definition longrat.cc:2672

Definition at line 81 of file p_Numbers.h.

## n_Add_FieldZp

#define n_Add_FieldZp | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
npAddM(n1,n2,r)
npAddM
static number npAddM(number a, number b, const coeffs r)
Definition modulop.h:124

Definition at line 67 of file p_Numbers.h.

## n_Add_RingGeneral

#define n_Add_RingGeneral | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
n_Add_FieldGeneral(n1, n2, r)
n_Add_FieldGeneral
static FORCE_INLINE number n_Add_FieldGeneral(number n1, number n2, const coeffs r)
Definition p_Numbers.h:27

Definition at line 52 of file p_Numbers.h.

## n_Copy_FieldQ

#define n_Copy_FieldQ | ( |  | n,
|  |  | r )

Value:
nlCopy(n,r)
nlCopy
LINLINE number nlCopy(number a, const coeffs r)
Definition longrat.cc:2624

Definition at line 78 of file p_Numbers.h.

## n_Copy_FieldZp

#define n_Copy_FieldZp | ( |  | n,
|  |  | r )

Value:
n

Definition at line 64 of file p_Numbers.h.

## n_Copy_RingGeneral

#define n_Copy_RingGeneral | ( |  | n,
|  |  | r )

Value:
n_Copy_FieldGeneral(n, r)
n_Copy_FieldGeneral
static FORCE_INLINE number n_Copy_FieldGeneral(number n, const coeffs r)
Definition p_Numbers.h:18

Definition at line 49 of file p_Numbers.h.

## n_Delete_FieldQ

#define n_Delete_FieldQ | ( |  | n,
|  |  | r )

Value:
nlDelete(n,r)
nlDelete
LINLINE void nlDelete(number *a, const coeffs r)
Definition longrat.cc:2637

Definition at line 79 of file p_Numbers.h.

## n_Delete_FieldZp

#define n_Delete_FieldZp | ( |  | n,
|  |  | r )

Value:
do {} while (0)

Definition at line 65 of file p_Numbers.h.

## n_Delete_RingGeneral

#define n_Delete_RingGeneral | ( |  | n,
|  |  | r )

Value:
n_Delete_FieldGeneral(n, r)
n_Delete_FieldGeneral
static FORCE_INLINE void n_Delete_FieldGeneral(number *p, const coeffs r)
Definition p_Numbers.h:21

Definition at line 50 of file p_Numbers.h.

## n_Equal_FieldQ

#define n_Equal_FieldQ | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
nlEqual(n1,n2,r)
nlEqual
LINLINE BOOLEAN nlEqual(number a, number b, const coeffs r)
Definition longrat.cc:2568

Definition at line 84 of file p_Numbers.h.

## n_Equal_FieldZp

#define n_Equal_FieldZp | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
npEqualM(n1,n2,r)
npEqualM
#define npEqualM(A, B, r)
Definition modulop.h:259

Definition at line 70 of file p_Numbers.h.

## n_Equal_RingGeneral

#define n_Equal_RingGeneral | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
n_Equal_FieldGeneral(n1, n2, r)
n_Equal_FieldGeneral
static FORCE_INLINE BOOLEAN n_Equal_FieldGeneral(number n1, number n2, const coeffs r)
Definition p_Numbers.h:33

Definition at line 54 of file p_Numbers.h.

## n_InpAdd_FieldQ

#define n_InpAdd_FieldQ | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
nlInpAdd(n1,n2,r)
nlInpAdd
LINLINE void nlInpAdd(number &a, number b, const coeffs r)
Definition longrat.cc:2690

Definition at line 87 of file p_Numbers.h.

## n_InpAdd_FieldZp

#define n_InpAdd_FieldZp | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
npInpAddM(n1,n2,r)
npInpAddM
static void npInpAddM(number &a, number b, const coeffs r)
Definition modulop.h:129

Definition at line 73 of file p_Numbers.h.

## n_InpAdd_RingGeneral

#define n_InpAdd_RingGeneral | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
n_InpAdd(n1, n2, r)
n_InpAdd
static FORCE_INLINE void n_InpAdd(number &a, number b, const coeffs r)
addition of 'a' and 'b'; replacement of 'a' by the sum a+b
Definition coeffs.h:649

Definition at line 58 of file p_Numbers.h.

## n_InpMult_FieldQ

#define n_InpMult_FieldQ | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
nlInpMult(n1,n2,r)
nlInpMult
LINLINE void nlInpMult(number &a, number b, const coeffs r)
Definition longrat.cc:2756

Definition at line 86 of file p_Numbers.h.

## n_InpMult_FieldZp

#define n_InpMult_FieldZp | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
npInpMultM(n1,n2,r)
npInpMultM
static void npInpMultM(number &a, number b, const coeffs r)
Definition modulop.h:86

Definition at line 72 of file p_Numbers.h.

## n_InpMult_RingGeneral

#define n_InpMult_RingGeneral | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
n_InpMult_FieldGeneral(n1, n2, r)
n_InpMult_FieldGeneral
static FORCE_INLINE void n_InpMult_FieldGeneral(number &n1, number n2, const coeffs r)
Definition p_Numbers.h:42

Definition at line 57 of file p_Numbers.h.

## n_IsZero_FieldQ

#define n_IsZero_FieldQ | ( |  | n,
|  |  | r )

Value:
nlIsZero(n,r)
nlIsZero
LINLINE BOOLEAN nlIsZero(number za, const coeffs r)
Definition longrat.cc:2604

Definition at line 83 of file p_Numbers.h.

## n_IsZero_FieldZp

#define n_IsZero_FieldZp | ( |  | n,
|  |  | r )

Value:
npIsZeroM(n,r)
npIsZeroM
#define npIsZeroM(A, B)
Definition modulop_inl.h:37

Definition at line 69 of file p_Numbers.h.

## n_IsZero_RingGeneral

#define n_IsZero_RingGeneral | ( |  | n,
|  |  | r )

Value:
n_IsZero_FieldGeneral(n, r)
n_IsZero_FieldGeneral
static FORCE_INLINE BOOLEAN n_IsZero_FieldGeneral(number n, const coeffs r)
Definition p_Numbers.h:30

Definition at line 53 of file p_Numbers.h.

## n_Mult_FieldQ

#define n_Mult_FieldQ | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
nlMult(n1,n2,r)
nlMult
LINLINE number nlMult(number a, number b, const coeffs r)
Definition longrat.cc:2708

Definition at line 80 of file p_Numbers.h.

## n_Mult_FieldZp

#define n_Mult_FieldZp | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
npMultM(n1,n2,r)
npMultM
static number npMultM(number a, number b, const coeffs r)
Definition modulop.h:71

Definition at line 66 of file p_Numbers.h.

## n_Mult_RingGeneral

#define n_Mult_RingGeneral | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
n_Mult_FieldGeneral(n1, n2, r)
n_Mult_FieldGeneral
static FORCE_INLINE number n_Mult_FieldGeneral(number n1, number n2, const coeffs r)
Definition p_Numbers.h:24

Definition at line 51 of file p_Numbers.h.

## n_Neg_FieldQ

#define n_Neg_FieldQ | ( |  | n,
|  |  | r )

Value:
nlNeg(n,r)
nlNeg
LINLINE number nlNeg(number za, const coeffs r)
Definition longrat.cc:2653

Definition at line 85 of file p_Numbers.h.

## n_Neg_FieldZp

#define n_Neg_FieldZp | ( |  | n,
|  |  | r )

Value:
npNegM(n,r)
npNegM
static number npNegM(number a, const coeffs r)
Definition modulop.h:174

Definition at line 71 of file p_Numbers.h.

## n_Neg_RingGeneral

#define n_Neg_RingGeneral | ( |  | n,
|  |  | r )

Value:
n_Neg_FieldGeneral(n, r)
n_Neg_FieldGeneral
static FORCE_INLINE number n_Neg_FieldGeneral(number n, const coeffs r)
Definition p_Numbers.h:36

Definition at line 55 of file p_Numbers.h.

## n_Sub_FieldQ

#define n_Sub_FieldQ | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
nlSub(n1,n2,r)
nlSub
LINLINE number nlSub(number la, number li, const coeffs r)
Definition longrat.cc:2738

Definition at line 82 of file p_Numbers.h.

## n_Sub_FieldZp

#define n_Sub_FieldZp | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
npSubM(n1,n2,r)
npSubM
static number npSubM(number a, number b, const coeffs r)
Definition modulop.h:134

Definition at line 68 of file p_Numbers.h.

## n_Sub_RingGeneral

#define n_Sub_RingGeneral | ( |  | n1,
|  |  | n2,
|  |  | r )

Value:
n_Sub_FieldGeneral(n1, n2, r)
n_Sub_FieldGeneral
static FORCE_INLINE number n_Sub_FieldGeneral(number n1, number n2, const coeffs r)
Definition p_Numbers.h:39

Definition at line 56 of file p_Numbers.h.

## Function Documentation

## n_Add_FieldGeneral()

FORCE_INLINE number n_Add_FieldGeneral | ( | number | n1,
|  | number | n2,
|  | const coeffs | r )

static

Definition at line 27 of file p_Numbers.h.

{ return n_Add(n1, n2, r); }
n_Add
static FORCE_INLINE number n_Add(number a, number b, const coeffs r)
return the sum of 'a' and 'b', i.e., a+b
Definition coeffs.h:653

## n_Copy_FieldGeneral()

FORCE_INLINE number n_Copy_FieldGeneral | ( | number | n,
|  | const coeffs | r )

static

Definition at line 18 of file p_Numbers.h.

{ return n_Copy(n,r); }
n_Copy
static FORCE_INLINE number n_Copy(number n, const coeffs r)
return a copy of 'n'
Definition coeffs.h:457

## n_Delete_FieldGeneral()

FORCE_INLINE void n_Delete_FieldGeneral | ( | number * | p,
|  | const coeffs | r )

static

Definition at line 21 of file p_Numbers.h.

{ n_Delete(p,r); }
p
int p
Definition cfModGcd.cc:4086
n_Delete
static FORCE_INLINE void n_Delete(number *p, const coeffs r)
delete 'p'
Definition coeffs.h:461

## n_Equal_FieldGeneral()

FORCE_INLINE BOOLEAN n_Equal_FieldGeneral | ( | number | n1,
|  | number | n2,
|  | const coeffs | r )

static

Definition at line 33 of file p_Numbers.h.

{ return n_Equal(n1, n2, r); }
n_Equal
static FORCE_INLINE BOOLEAN n_Equal(number a, number b, const coeffs r)
TRUE iff 'a' and 'b' represent the same number; they may have different representations.
Definition coeffs.h:466

## n_InpAdd_FieldGeneral()

FORCE_INLINE void n_InpAdd_FieldGeneral | ( | number & | n1,
|  | number | n2,
|  | const coeffs | r )

static

Definition at line 45 of file p_Numbers.h.

{ n_InpAdd(n1, n2, r); }

## n_InpMult_FieldGeneral()

FORCE_INLINE void n_InpMult_FieldGeneral | ( | number & | n1,
|  | number | n2,
|  | const coeffs | r )

static

Definition at line 42 of file p_Numbers.h.

{ n_InpMult(n1, n2, r); }
n_InpMult
static FORCE_INLINE void n_InpMult(number &a, number b, const coeffs r)
multiplication of 'a' and 'b'; replacement of 'a' by the product a*b
Definition coeffs.h:644

## n_IsZero_FieldGeneral()

FORCE_INLINE BOOLEAN n_IsZero_FieldGeneral | ( | number | n,
|  | const coeffs | r )

static

Definition at line 30 of file p_Numbers.h.

{ return n_IsZero(n, r); }
n_IsZero
static FORCE_INLINE BOOLEAN n_IsZero(number n, const coeffs r)
TRUE iff 'n' represents the zero element.
Definition coeffs.h:470

## n_Mult_FieldGeneral()

FORCE_INLINE number n_Mult_FieldGeneral | ( | number | n1,
|  | number | n2,
|  | const coeffs | r )

static

Definition at line 24 of file p_Numbers.h.

{ return n_Mult(n1, n2, r); }
n_Mult
static FORCE_INLINE number n_Mult(number a, number b, const coeffs r)
return the product of 'a' and 'b', i.e., a*b
Definition coeffs.h:639

## n_Neg_FieldGeneral()

FORCE_INLINE number n_Neg_FieldGeneral | ( | number | n,
|  | const coeffs | r )

static

Definition at line 36 of file p_Numbers.h.

{ return n_InpNeg(n, r); }
n_InpNeg
static FORCE_INLINE number n_InpNeg(number n, const coeffs r)
in-place negation of n MUST BE USED: n = n_InpNeg(n) (no copy is returned)
Definition coeffs.h:560

## n_Sub_FieldGeneral()

FORCE_INLINE number n_Sub_FieldGeneral | ( | number | n1,
|  | number | n2,
|  | const coeffs | r )

static

Definition at line 39 of file p_Numbers.h.

{ return n_Sub(n1, n2, r); }
n_Sub
static FORCE_INLINE number n_Sub(number a, number b, const coeffs r)
return the difference of 'a' and 'b', i.e., a-b
Definition coeffs.h:658